var UTIL = {
    'arrayIncludes': function (arr, find) {
        var item, idx;

        for (idx in arr) {
            item = arr[idx];

            if (item.equals(find)) {
                return true;
            }
        }

        return false;
    },
    'groupsArrayFromName': function (arr) {
        var groupList = [],
            group,
            name,
            idx;

        for (idx in arr) {
            name = arr[idx];
            group = groups.getGroupIdFromName(name);

            if (group !== null) {
                groupList.push(group);
            } else {
                logger.warn("Group not found for name: " + name);
            }
        }

        return groupList;
    }
};

var userConfig;

if (UTIL.arrayIncludes(json.whitelist, username)) {
    userConfig = json.users[username];

    if (userConfig !== null) {
        userInfo.setUserRole(userConfig.role);
        userInfo.setPrimaryGroupId(groups.getGroupIdFromName(userConfig.primary));
        userInfo.setSecondaryGroupIds(UTIL.groupsArrayFromName(userConfig.groups));
    } else {
        userInfo.setStatus('ERROR');
        userInfo.setMessage('Your user is not configured for access.');
        logger.error('Username not found in config JSON.');
    }
} else {
    userInfo.setStatus('DENIED');
    userInfo.setMessage('Contact Jane Doe (555-5555 x5555) for access to this application.');
}

// Print debugging information to the logs

var groupsList = groups.getGroupList(),
    group;

logger.debug('*** User Information ***');

logger.debug('User: ' + username);
logger.debug('Info: ' + userInfo.toString());

logger.debug('*** Group Information ***');

for (var idx in groupsList) {
    group = groupsList[idx];

    logger.debug('Group ' + group.getGroupId() + ': ' + group.getGroupName());
}
